using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;

namespace SQLService
{
	/// <summary>
	/// Summary description for DBOperater.
	/// </summary>
	/// 

	// ݿ
	public class DBOperater
	{
		public DBOperater()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public virtual bool ExecuteNonQuery(string sql)
		{
			return true;
		}

		public virtual DataSet ExecuteDataSet(string sql)
		{
			return null;
		}
	}

	// SQL Server 
	public class DBSqlServerOperater : DBOperater
	{
		public DBSqlServerOperater(string DBConnectionString)
		{
			m_SqlConnection = new SqlConnection(DBConnectionString);		
		}

		public override bool ExecuteNonQuery(string sql)
		{
			if(sql == "")
				return false;

			m_SqlConnection.Open();

			SqlCommand command = m_SqlConnection.CreateCommand();
			command.CommandText = sql;

			command.ExecuteNonQuery();

			m_SqlConnection.Close();
			return true;
		}

		public override DataSet ExecuteDataSet(string sql)
		{
			if(sql == "")
				return null;

			m_SqlConnection.Open();

			SqlDataAdapter da = new SqlDataAdapter(sql,m_SqlConnection);

			DataSet ds = new DataSet();
			da.Fill(ds);

			m_SqlConnection.Close();
			return ds;
		}

		private SqlConnection m_SqlConnection;
	}

	// OleDb 
	public class DBAccessOperater : DBOperater
	{
		public DBAccessOperater(string DBConnectionString)
		{
			m_OleDbConnection = new OleDbConnection(DBConnectionString);		
		}

		public override bool ExecuteNonQuery(string sql)
		{
			if(sql == "")
				return false;

			m_OleDbConnection.Open();

			OleDbCommand command = m_OleDbConnection.CreateCommand();
			command.CommandText = sql;

			command.ExecuteNonQuery();

			m_OleDbConnection.Close();
			return true;
		}

		public override DataSet ExecuteDataSet(string sql)
		{
			if(sql == "")
				return null;

			m_OleDbConnection.Open();

			OleDbDataAdapter da = new OleDbDataAdapter(sql,m_OleDbConnection);

			DataSet ds = new DataSet();
			da.Fill(ds);

			m_OleDbConnection.Close();
			return ds;
		}
		
		private OleDbConnection	m_OleDbConnection;
	}
}
